<template>
  <div>
      <ob-table
          :group-by="groupBy"
          :columns="columns"
          :items="items"
          :tableLayoutFixed="false"
          :footerDisabled="true"
          :showAddButton="false"
          :loading="loading"
          :page-limit="-1"
          :is-smart-pagination="false"
          :rowClassFunc="getRowClass"
          data-qa="dataQa"
          :class="{
            'intracity-table': viewMode === 'intracity',
            'conatiner-table': viewMode === 'container',
            'header-hidden': hideHeader,
          }"
      >
        <template slot="type" slot-scope="{ data }">

          <div v-if="data.item.service" class="resource">
            <i class="icon resource__icon" v-html="getServiceIcon({ uuid: data.item.service.serviceTypeUuid }).icon"></i>
            <span class="resource__title">
              {{ data.item.title }}
            </span>
          </div>
          <div v-else class="resource-group" @click="$emit('toggleRow',direction, data.item)">
            <i class="resource-group__icon icon chevron-down" :class="[data.item.isOpen ? 'opened' : 'closed']" />
            <div class="resource-group__title">{{ data.item.title }}</div>
          </div>

        </template>

        <template slot="unit" slot-scope="{ data }">
          <div v-if="data.item.service">
            <div v-for="(unit, i) in data.item.service.serviceUnits" :key="i">{{ unit.title }}</div>
          </div>
        </template>

        <template slot="fixed" slot-scope="data">
          <template v-if="viewMode === 'intracity' && !data.data.item.isGroup">
            <FixedPriceView
                :price="data.data.item.fixedPrice"
                :departureUuid="direction.locationUuid"
                :arrivalUuid="direction.locationUuid"
                :resourceUuid="data.data.item.serviceUuid"
                :fixedPriceCurrently="data.data.item.fixedPriceCurrently"
                @update="$emit('update')"
            />
          </template>
          <template v-else-if="viewMode === 'container'">
            <ContainerFixedPrice
                :key="data.data.item.key"
                :price="data.data.item.fixedPrice"
                :directionUuid="direction.directionUuid"
                :clusterFromUuid="direction.clusterFromUuid"
                :clusterToUuid="direction.clusterToUuid"
                :resourcesGroupUuid="data.data.item.resourcesGroupUuid"
                :serviceUuid="data.data.item.serviceUuid"
                :isFixedPriceCurrently="data.data.item.isFixedPriceCurrently"
                @update="$emit('update')"
            />
          </template>
          <template v-else>
            <PriceView
                :price="data.data.item.fixedPrice"
                :km-only="true"
            />
          </template>

        </template>

        <template slot="avg" slot-scope="data">
          <PriceView
            :price="data.data.item.averagedPrice"
            :km-only="!direction.directionUuid"
          />
        </template>

        <template slot="expert" slot-scope="data">
          <template v-if="data.data.item.expertPrice && data.data.item.expertPrice.priceKm > 0">
            <PriceView
              :price="data.data.item.expertPrice"
              :km-only="!direction.directionUuid"
              v-on:click="$emit('openExpertPriceModal', data.data.item, direction)"
            />
          </template>
          <template v-else>
            <div v-if="viewMode === 'cluster'" class="addExpTariff" v-on:click="$emit('openExpertPriceModal', data.data.item, direction)">
              Тариф не назначен.<br><span>Добавить.</span>
            </div>
          </template>
        </template>

        <template slot="base" slot-scope="data">
          <PriceView
            :price="data.data.item.basePrice"
            :km-only="!direction.directionUuid"
          />
        </template>

        <template slot="trust" slot-scope="data">
          <div
              v-if="data.data.item.basePriceReliability"
              class="reliability"
          >
            {{ data.data.item.basePriceReliability }}%
          </div>
        </template>

      </ob-table>

  </div>
</template>

<script>
import ObTable from 'common-components/src/obComponents/obTable';
import { getServiceIcon } from '@/constants/order';
import PriceView from './components/priceView';
import FixedPriceView from './components/fixedPriceView';
import ContainerFixedPrice from './components/containerFixedPrice';
import numberWithSpaces from '@/utils/formatNumber';
import {mapActions, mapGetters} from "vuex";

export default {
  name: 'MonitorTable',
  components: {
    ObTable,
    PriceView,
    FixedPriceView,
    ContainerFixedPrice,
  },
  props: {
    viewMode: {
      type: String,
      default: () => '',
    },
    direction: {
      type: Object,
      default: () => ({}),
    },
    groupBy: {
      type: String,
      default: () => '',
    },
    columns: {
      type: Array,
      default: () => [],
    },
    items: {
      type: Array,
      default: () => [],
    },
    loading: {
      type: Boolean,
      default: () => false,
    },
    hideHeader: {
      type: Boolean,
      default: () => false,
    },
    dataQa: {
      type: String,
      default: () => '',
    },
  },
  data() {
    return {
      openGroups: {},
      compatibleStationsData: {},
      agglomerationsList: [],
    };
  },
  computed: {
    ...mapGetters({
      locations: 'base_prices/locations',
      services: 'base_prices/services',
      getLocationTitleFromUuid: 'base_prices/getLocationTitleFromUuid',
      getLocationIconFromUuid: 'base_prices/getLocationIconFromUuid',
    }),
    getAccordionIcon() {
      let icon = '';
      if( this.viewMode === 'intracity') {
        icon = 'city-sm';
      } else if ( this.viewMode === 'cluster') {
        icon = 'aglomeration';
      }
      return icon;
    },
  },
  methods: {
    ...mapActions({
      getLocations: 'base_prices/getLocations',
      getServices: 'base_prices/getServices',
    }),
    getServiceIcon,
    getRowClass(data) {
      return data.item.showResource ? 'show-item ' + (data.item.isGroup ? 'is-group' : '') : 'hidden';
    },
    priceFormat(value, divider = 100) {
      return numberWithSpaces(value, divider).replace('.', ',');
    },
  },
};
</script>

<style lang="scss" scoped>

$cobalt-border: #d3e1f1;
$gray-light: #9da0ac;

@import '~common-components/src/static/css/mixins';

.baseprices-clustering-acc-content{
  margin-left: 55px;
}

.page-controls {
  position: absolute;
  right: 0;
  margin: -40px 35px 0 20px;
  display: flex;
  align-items: center;
  button {
    @include font-mixin(12px, 16px, 500, $blue-700, 1.6px);
    text-transform: uppercase;
  }
}

.all-directions{
  color: $gray-slate;
}

.cluster-list {
  position: relative;

  ul {
    list-style-type: none;
  }
  &-item {
    border-bottom: 1px solid #e5edf9;
    &-info {
      cursor: pointer;
      display: flex;
      background: $light-lavender ;
      color: $blue-dust;
      padding: 14px 14px;
      //  border-bottom: 1px solid $cobalt-border;
      span {
        margin: 0 15px;
      }
      i {
        font-size: 16px;
      }
    }
  }
  &__loader {
    position: absolute;
    background: $background-white;
    opacity: 0.8;
    left: 0;
    bottom: 0;
    width: 100%;
    height: 100%;
    &-icon {
      position: absolute;
      top: calc(50% - 20px);
      left: calc(50% - 20px);
      width: 40px;
      height: 40px;
    }
  }
}

.resource{
  display: flex;
  align-items: center;
  padding-left: 65px;

  .resource__title{
    font-width: 400;
  }

  .resource__icon{
    width: 65px;
    margin-right: 20px;
  }
}

.resource-group{
  position: relative;
  padding-left: 65px;
  cursor: pointer;

  &__title{
    color: $blue-dust;
  }

  &__icon{
      position: absolute;
      top: 50%;
      left: 30px;
      transform: translateY(-50%);
      font-size: 23px;
      color: $blue-dust;
      transition: all 0.2s linear;

      &.closed {
        transform: translateY(-50%) rotate(-90deg);
      }
  }
}


.reliability{
  color: $deep-blue;
  text-align: right;
}

.td-container {
  position: relative;
}
::v-deep {

  .expert {
    cursor: pointer;
  }

  .ob-accordion__title {
    min-height: 60px;
    border-bottom: 1px solid $cobalt-border;
    justify-content: flex-start;
  }

  .ob-accordion__title-text {
    flex-grow: 0;
    color: $blue-dust;
    width: 250px;
    margin-right: 20px;
  }

  .accordion-title-item {
    display: flex;
    align-items: center;
    width: 100%;

    &__city {
      margin-right: 10px;
      color: $blue-dust;

      i {
        margin-right: 10px;
      }
    }

    &__distance {
      color: $gray-slate;
    }

    &__divider {
      margin-right: 10px;
      color: $blue-dust;
    }

    .compatible_stations{
      margin-left: auto;
      color: $blue-dust;
      display: inline-flex;
      align-items: center;

      i{
        margin-right: 10px;
        font-size: 18px;
      }
    }
  }

  .table-data{
    border-collapse: collapse;
    border: 1px solid #E5EDF9;

    * {
      box-sizing: border-box;
    }

    tr > th:first-child{
      padding-left: 35px;
    }

    thead.fixed tr th{
      border-top: 1px solid #fff;
      box-shadow: none;
      border-bottom: 1px solid #D3E1F1;
    }

    tbody{
      & > tr > td{
        border: 1px solid $lavender;
      }

      & > tr > td:nth-child(1){
        border-right: none;
      }

      & > tr > td:nth-child(2){
        border-left: none;
      }

      .td-container{
        min-height: 60px;
      }

    }
    .td-container > div{
      width: 100%;
    }

    .data-row.hidden{
      display: none;
    }
    .is-group{
      background-color: $light-lavender;
    }

    .ob-accordion__content{
      margin-bottom: 10px;
    }

  }

  .header-hidden table{
    margin-top: -2px;
  }

  .header-hidden thead, .header-hidden thead *{
    height: 0;
    min-height: 0;
    visibility: hidden;
    padding-top: 0;
    padding-bottom: 0;
    margin-top: 0;
    margin-bottom: 0;
  }

  .intracity-table{
    thead.fixed tr th:nth-child(4) .column-title,
    thead.fixed tr th:nth-child(5) .column-title,
    thead.fixed tr th:nth-child(7) .column-title{
      color: $color-grey-border;
    }
  }
  .conatiner-table{
    thead.fixed tr th:nth-child(5) .column-title{
      color: $color-grey-border;
    }
  }

  .table-footer {
    position: relative;
    display: flex;
    align-items: center;
    justify-content: space-between;
    height: 40px;
    padding: 0 15px;
    text-transform: uppercase;
    font-size: 12px;
    border-top: 1px $lavender solid;
    border-bottom: 1px solid transparent;
    color: $shale-gray;

    .total-count{
      flex-shrink: 0;
      margin-right: 20px;
    }
  }

  .addExpTariff{
    font-size: 12px;
    text-align: right;
    span {
      color: $blue-dust;
    }
  }

}
</style>
